#!/usr/bin/ruby
# Author::  cho45(砂糖) <cho45@lowreal.net>
# License:: Creative Commons by-nc

require "fcgi"
require "erb"
require "cgi"
$ERROR = DATA.read

FCGI.each do |fcgi|
	$stdout = fcgi.out
	$stdin = fcgi.in
	
	ENV.replace(fcgi.env)
	

	begin
		Thread.start do
			Dir.chdir(File.dirname(fcgi.env["SCRIPT_FILENAME"]))
			load(fcgi.env["SCRIPT_FILENAME"], true)
		end.join
	rescue SystemExit
		# nothing to do
	rescue Exception => e


		@cgi = CGI.new
		
		puts @cgi.header({
			"status" => "SERVER_ERROR",
			"type" => @cgi.user_agent.match(/IE/) ? "text/html" : "application/xhtml+xml"
		})

		e.backtrace.slice!(-6..-1)
		e.backtrace.unshift(e.message) if e.class == SyntaxError

		backtrace = e.backtrace.collect do |l|
			CGI.escapeHTML(l)
		end

		lines = {}

		ERB.new($ERROR, $SAFE, ">").run(binding)
	end
	fcgi.finish
end


__END__
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title>500 Internal Server Error</title>
		<style type="text/css"><![CDATA[
* {
	margin: 0;
	padding: 0;
	text-decoration: none;
	font-size: 100%;
	font-weight: normal;
	font-style: normal;
	background: transparent;
	border: none;
}

html, body {
	background: #333;
	color: #fff;
	line-height: 1.33;
}

a:link {
	color: #fff;
	text-decoration: underline;
}

a:hover {
	text-decoration: none;
}

em {
	font-weight: bold;
}


h1 {
	margin: 1em 10%;
	font-size: 200%;
}

h2 {
	font-size: 150%;
	font-weight: bold;
}

dt {
	font-weight: bold;
}

dd {
	margin: 0 0 1em 2em;
	font-size: 80%;
}

ol {
	padding: 0 0 0 2em;
}

ul, ol, p, dl {
	margin: 0.5em 0;
}

span.l {
	display: block;
	white-space: pre;
	font-family: "Lucida Console", monospace;
}
span.l em {
	color: #f00;
	font-weight: normal;
			}

span.linenum {
	font-weight: bold;
}

dd.backtrace div.code {
	border: 1px solid #000;
	padding: 0.5em;
	overflow: auto;
	background: #efefef;
}
dd.error,
dd.backtrace {
	font-family: "Lucida Console", monospace;
}


.error-info,
.message {
	border: 3px solid #000;
	color: #000;
	background: #fff;
	margin: 1em 10%;
	padding: 1em;
}

p.filename {
	font-weight: bold;
}

#footer {
	text-align: right;
	margin: 1em 10%;
	padding: 0 3px;
}

#footer * {
	display: inline;
	font-size: 80%;
}

#footer * * {
	font-size: 100%;
}



]]></style>
	</head>
	<body>
		<h1>500 Internal Server Error</h1>
		<div id="content">
			<div class="message">
				<p>Sorry. Error happened on processing your request.</p>
			</div>
			<div class="error-info">
				<dl>
					<dt>Error</dt>
					<dd class="error">
						<p>
							class: <em><%=CGI.escapeHTML(e.class.to_s)%></em>
							<%=e.class < StandardError ? " &lt; StandardError" : "" %>
						</p>
						<p><%=CGI.escapeHTML(e.message).sub(/for/, "for<br />")%></p>
					</dd>

					<dt>Backtrace</dt>
					<dd class="backtrace">
						<% backtrace.each do |l| %>
						<% _, filename, linenum =  */^(.+?):(\d+)/.match(l) %>
						<% lines[filename] ||= File.readlines(filename)%>
						<% linenum = linenum.to_i %>
						<p class="filename"><%=l%></p>
						<div class="code">
							<% lines[filename].each_with_index do |l, n|
								n += 1
								next if n < linenum - 5
								break if n > linenum + 5 %>
							<% l = CGI.escapeHTML(l.gsub(/\t/, "  ").gsub(/\n/, ""))%>
							<% if n == linenum %>
							<span class="l"><em><span class="linenum"><%="% 4d" % n%>:</span> <%=l%></em></span>
							<% else %>
							<span class="l"><span class="linenum"><%="% 4d" % n%>:</span> <%=l%></span>
							<% end %>

							<% end %>
						</div>
						<% end %>
					</dd>
				</dl>
			</div>
		</div>
		<div id="footer">
			<p><a href="http://www.ruby-lang.org/">Ruby <%=RUBY_VERSION%></a></p>
			<address><a href="mailto:cho45@lowreal.net">cho45@lowreal.net</a></address>
		</div>
	</body>
</html>
